from pylab import *

#simlss data
k,pk,pknos=loadtxt("simlss_dr9_z0.5.txt",skiprows=2,unpack=True,usecols=(0,1,2))

#CLASS: setup simlss
#class: BAO: zd=1059.5 rs(zd)=149.062
from astropy.io import fits

#no baryons
t= fits.open("simlss-camel_z0.8.fits")
kc=t[3].data['k']
pkc=t[3].data['pklin']
t.close()

t= fits.open("simlss_nob.fits")
k=t[3].data['k']
pknob=t[3].data['pklin']
t.close()



#posiiton des pics
d=pkc/pknob
diff=d-roll(d,1)
w=logical_or(logical_and(diff>0,roll(diff,1)<0),logical_and(diff<0,roll(diff,1)>0))
kb=k[w]

figure()
subplot(211)
plot(k,pk,label='EH98')
#plot(k,pknos,label='EH98(no_osc)')
plot(k,pkc,label='CLASS')
plot(k,pknob,label='CLASS (no_b)')
xlim(0,0.2)
xlabel("k (1/Mpc)")
legend()
subplot(212)
plot(k,1-pk/pkc)
xlim(0,0.2)
ylabel("(Pk(EH)-Pk(CLASS))/Pk(EH)")


figure()
ax=subplot(211)
plot(k,pkc/pknob,label="CLASS")
xlim(0,0.2)
ylabel("Pk/Pk_nob")
legend()
#d'apres class
s=149.062
m=2*arange(1,10)+1
kp=m*pi/(2*s)
[axvline(x=kk,c='k',ls='dashed') for kk in kp]
[axvline(x=kk,c='b') for kk in kb]

knode=arange(0.02,0.4,0.04)
knode=r_[0.005,knode]
knode=knode

from scipy.interpolate import LSQUnivariateSpline
sm= LSQUnivariateSpline(k, pkc, knode,ext=1,k=3)
pkno=sm(k)

##legend()
##[axvline(x=kk,c='k',ls='dashed') for kk in knode]

pkwig=pkc/pkno

subplot(212,sharex=ax,label='CLASS')
legend()
plot(k,pkwig,label='spline')
plot(k,pk/pknos,label='EH98(no_osc)')

xlabel("k (1/Mpc)")
ylabel("Pk/Pk_smooth")
[axvline(x=kk,c='b') for kk in kb]
xlim(0,0.2)
legend()

#fit ka

#fit fonction wiggles
from scipy import optimize
def fitfunc(k,A,ka):
    return 1+A*sin(2*pi*k/ka)

k_cut=[0.02,0.20]
p0=[0.1,2*pi/s]
cut=logical_and(k>k_cut[0],k<k_cut[1])

figure()
pkwig=pkc/pknos
plot(k,pkwig)
p, pcov=optimize.curve_fit(fitfunc,k[cut],pkwig[cut],p0)

plot(k,fitfunc(k,p[0],p[1]),'k',label="Fit")
xlim((k_cut[0],k_cut[1]))

print("s_rec={}".format(2*pi/p[1]))
show()
