from pylab import *
from astropy.io import fits
from scipy.signal import savgol_filter

fn="statPk_nonu.fits"
print("reading "+fn)
hdulist = fits.open(fn)
hdulist.info()

h=hdulist[3].header
data=hdulist[3].data
hdulist.close()

k=data['k']
pk=data['pklin']


figure()
loglog(k,pk)
xlabel("k (1/Mpc)")
ylabel(r'P(k) ($1/Mpc^3$)')
ommh2=0.141
s=145.077
keq=0.01
m=2*arange(1,8)+1
k_peaks=m*pi/(2*s)

bnode=8.41*ommh2**0.435

re=1/(1+(bnode/(k_peaks*s))**3)**(1./3)

#bof
#k_peaks2=k_peaks*re


axvline(x=keq,c='k')
[axvline(x=xx,c='k',ls='dashed') for xx in k_peaks]
#[axvline(x=xx,c='k') for xx in k_peaks2]

figure()
pk_s=savgol_filter(pk,151,3)
semilogx(k,pk-pk_s)
xlabel("k (1/Mpc)")
ylabel(r'P(k) ($1/Mpc^3$)')
[axvline(x=xx,c='k',ls='dashed') for xx in k_peaks]
#[axvline(x=xx,c='k') for xx in k_peaks2]

show()
